/*************************************************************
*                                                            *
*           Projekt         :   TERRA.AAS                    *
*                                                            *
*           Datei           :   TERR_AAS.H                   *
*           erster Pixel    :   19. 1.1993                   *
*           letzte nderung :   19. 1.1993                   *
*                                                            *
*************************************************************/


/*----------------- Konstanten -----------------------------*/
#define	TERRA_IPR_MAX 15

enum	{
			PATTERN,

			TERRA_IR_MAX
		};


/*-----------------	Strukturen -----------------------------*/
typedef struct	{
					WORD		x;
					WORD		y;
				}
				TERRA_HLOC;

typedef struct	{
					char		name[20];
					WORD		width;
					WORD		height;

					TERRA_HLOC	loc[TERRA_IPR_MAX];
				}
				TERRA_HROW;

typedef struct	{
					char		name[16];
					int			row_amount;

					TERRA_HROW	row[TERRA_IR_MAX];
				}
				TERRA_HAAS;


/*-----------------	Daten ----------------------------------*/
TERRA_HAAS	haas_terra =
{
	"TERRA.AAS",
	1,
	{
		{
			"PATTERN",
			48,32,
			{
				{0,0},
				{48,0},
				{96,0},
				{144,0},
				{192,0},
				{240,0},
				{288,0},
				{336,0},
				{384,0},
				{432,0},
				{480,0},
				{528,0},
				{576,0},
				{624,0},
				{672,0}
			}
		}
	}
};


