#include "..\common.h"
#include <math.h>
#include "..\chs_ultd.gem\xxx.h"	/* resource-definition */

/*------------------------------------------------------------------------------

	strings

------------------------------------------------------------------------------*/
static char xxx_menu[]="";
static char xxx_author[]="";
static char xxx_date[]="";
static char xxx_text[]="";


/*------------------------------------------------------------------------------
		initialisierungsroutine,
			mu nach linken am anfang des text-segmentes stehen,
			d.h. im quelltext ganz vorne
------------------------------------------------------------------------------*/
COMMON	*common;			/* zeiger fr die routinen von chaos */

int errno;				/* damit der linker nicht motzt;
							sonst in pc_start deklariert */

X_CHAOS *ret_lsystem(COMMON *com)
{
extern X_CHAOS xxx;	/* deklariert am ende dieses quelltextes! */

	common=com;				/* merke com */
	return &xlsys;				/* gib eigene routinen zurck */
}

/*------------------------------------------------------------------------------

	daten-strukturen und globales

------------------------------------------------------------------------------*/
	/* parameter eines bildes (werden im objekt gespeichert) */
typedef struct
{
} XXX;

	/* bilderzeugungsparameter (parameter des ersten, letzten bildes,
										platz fr param. des akt. bildes!) */
typedef struct
{
} XXX_PAR;

/* optional
	/* parameter fr neu-berechnen */
typedef strcut
{
} XXX_NEU;
*/

	/* voreinstellungen */
typedef struct
{
} ;

	/* werte der voreinst. */
static XXX_SET xxx_set={
};

	/* voreinst. fr allg. param. */
static ALLG_PAR xxx_apar={1,"xxx",640,400,1,0,2};

	/* resource-bume */
static OBJECT ;

	/* typ der routine */
static int xxx_typ;

/*------------------------------------------------------------------------------

		parameter einlesen

------------------------------------------------------------------------------*/
	/* bearbeitung von exit-objekten */
static int par_button(int object,void *data,void *dw)
	/* return :	-3 -> weiter, kein redraw
				-2 -> weiter, redraw alles falls redraw_flag
				-1 -> weiter, redraw alles
				 0  -> ende
				>0 -> redraw objc nr.
	*/
{
}

	/* eingabe der parameter */
static int do_xxx_param(AP_DATA *ad)
{		/* return 0 -> abbr., 1 -> ok */
int ret;

	do {
		ret=common->xdialwind(1,xxx_ad,&xxx_set.param,0,par_button,ad,(int*)-1l,"lsystem")&0x7FFF;
		if ( ret==P_APAR &&!ad->local2!=2 ) {
			if ( common->get_allg_par(ad,xxx_typ,(int*)-1l) )
				common->write_ap_info(xxx_ad,P_PINFO,ad->ap);
		}
	} while ( ret!=P_OK && ret!=P_ABBR );
	return ret==P_OK;
}

	/* parameter fr neues bild */
static int xxx_param(int typ,AP_DATA *ad,int mode,int ks,GET_DATA *gd)
{
	/* parameter voreinstellen */
	/* ... */

	/* parameter eingeben */
	return do_xxx_param(ad);
}

/* optional
#define _SET_PARAM_
	/* parameter voreinstellen */
	/* voreinstellung holen und nach xxx_set kopieren! */
static void set_xxx_param(int typ,AP_DATA *ad)
{
}
*/

/* optional
#define _EXTENDED_
	/* aufgerufen durch ALT-make */
static void xxx_extended(int typ)
{
}
*/
	
	/* erzeuge parameter fr bild aus anfangs/endwerten */
static XXX *xxx_par(int typ,XXX_PAR *in,int nr,int anz)
{
	/* return 	parameter des bildes */
	/* 			0l -> allg. fehler, -1l -> speicherfehler */
}

/* optional
#define _NEU_
static int xxx_neu(int typ,X_DATA_P *param,ALLG_PAR *ap)
{
}

static XXX *xxx_neu_par(CHS_OBJC *objc,XXX_NEU *hueneu,int *change)
{
	/* return parameter des bildes */
}
*/

/* optional, darf aber nur fehlen, wenn parameter nicht zurckgesetzt werden mssen 
#define _NPAR_
	/* sezte parameter zurck (falls neu fr allg.param) */
static void xxx_npar(CHS_OBJC *objc)
{
}
*/

/* optional, sollte aber ex.
#define _SHOWPAR_
static int xxx_showpar(CHS_OBJC *object)
{
}
*/

/* optional
#define _DRPAR_
static void xxx_drpar(CHS_OBJC *object,DR_INFO *di)
{
}
*/

/* optional
#define _SHOWINFO_
static void xxx_showinfo(CHS_OBJC *ob)
{
}
*/

/* optional, sollte mglichst ex.
#define _INFO_
static void xxx_info(CHS_OBJC *objc,P_INFO *info)
{
LSYSTEM *ls;

	ls=(LSYSTEM*)objc->param->data;
	info->points=ls->pkte;
	info->iter=ls->iter;
	info->time=ls->time/200.0;
}
*/

/* optional
#define _BLOCK_
static void xxx_block(CHS_OBJC *object,double *x_min,double *x_max,double *y_min,double *y_max)
{
}
*/

/* optional
#define _PUNKT_
static void xxx_pkt(CHS_OBJC *object,double *x,double *y)
{
}
*/

/* optional
#define _PKTINFO_
void xxx_pktinfo)(CHS_OBJC *object,int x,int y)
{
}

	/* init_routinen */
static int xxx_init(int typ)
{
	/* return RET_OK/RET_ERROR */
}

/* optional
#define _CONVPAR_
static void xxx_conv_set(XXX_SET *ls,void (*conv_dpos)(DIAL_POS *dp))
{
}
*/

int xxx_draw(CHS_OBJC *objc,int width,int height,int colors,BITMAP *bitmap,int *xheight)
{
}

/* optional (wird aufgerufen, wenn bild nicht angefangen wird zu berechnen
#define _DONTDRAW_
int xxx_dontdraw(CHS_OBJC *objc)
{
}
*/

#pragma warn -sus

static CHAOS_1 ls_ch1={
"TMMWXXX",				/*	id	*/
xxx_menu,				/*	menue	*/
xxx_author, xxx_date,xxx_text,	/*	name, version, text	*/
sizeof(XXX_SET),&xxx_set,/*	sel_len, set */
&xxx_apar,
sizeof(XXX),sizeof(XXX_PAR),/*	par_len, make_len */
#ifdef _NEU_
	sizeof(XXX_NEU),0l,0,/* neu_len, neu_par, neu_flag */
#else
	0l,0l,-2,			/* neu_len, neu_par, neu_flag */
#endif
0,						/* xor_lines */
0,						/* xget-flag */
{64,32000,40,32000,		/* min/max width/height */
2,256,1},				/* min/max col, raster */
0l,						/* kein x_mem */

xxx_init,				/* do init */
xxx_param,				/* get_param */
xxx_par,				/* get_picpar */
#ifdef _SET_PARAM_
set_xxx_param,			/* set_parameter */
#else
0l
#endif
#ifdef _EXTENDED_
	xxx_extended		/* extended */
#else
	0l,
#endif
xxx_draw,				/* do_draw */
#ifdef _DONTDRAW_
	ls_dontdraw,		/* dont_draw */
#else
	0l
#endif
#ifdef _NEU_
	xxx_neu,
	xxx_neu_par
#else
	0l,						/* get_neu_param */
	0l,						/* make_neu_param */
#endif
#ifdef _NPAR_
	xxx_npar,				/* setze parameter zurck */
#else
	0l,
#endif
#ifdef _CONVPAR_
	xxx_conv_set,
#else
	0l,
#endif
};

static CHAOS_2 ls_ch2={
0l,						/* icon */
xxx_menu,				/* typ */
0,						/* last_flag */
0,						/* block flag, NUR 1 setzen, wenn xxx_block ex.!!!! */
#ifdef _SHOWPAR_
	xxx_showpar,			/* show_param */
#else
	0l,
#endif
#ifdef _SHOWINFO_
	xxx_showinfo,
#else
	0l,						/* show_info */
#endif
#ifdef _INFO_
	xxx_info,				/* get_info */
#else
	0l,
#endif
#ifdef _BLOCK_
xxx_block,						/* get block */
#else
	0l,
#endif
#ifdef _PUNKT_
	xxx_pkt,			/* punkt-koord. zurckgeben */
#else
	0l,
#endif
#ifdef _PKTINFO_
	xxx_pktinfo,		/* punktinfo anzeigen */
#else
	0l,
#endif
#ifdef _DRPAR_
	xxx_drpar,			/* parameter-strings fr drucken bereitstellen */
#else
	0l,
#endif
};

static X_CHAOS xxx={X_CHAOS_ID,
		1,	/* nur eine routine */
		&ls_ch1,&ls_ch2
};

