
/***********************************************************
 * SCHONER.C                                               *
 ***********************************************************
 * Alternativer Bildschirmschoner fr Null Mark!           *
 ***********************************************************
 * Das ist ein ziemlicher Chaos-Code! Sorry! Das Teil war  *
 * eigentlich nur als Gimmick gedacht. Daher ist das Kon-  *
 * zept eher "chaotisch"... Fehler sind bestimmt auch noch *
 * genug drin, frchte ich. It's just a gag! S.B. 24.1.93  *
 ***********************************************************
 * Verbesserungen und Erweiterungen sind jederzeit will-   *
 * kommen und drfen ohne Rcksprache mit mir durchgefhrt *
 * werden! Ich htte dann nur gerne so eine Version! Bin   *
 * im Mausnetz in @ ZW erreichbar.                         *
 ***********************************************************
 * (C)1993 by Stefan Becker                                *
 ***********************************************************
 * Compiler: PC 1.1 | Tabulatorweite: 4 | Rechner Atari-ST *
 ***********************************************************/

/***************
 * PC-Includes *
 ***************/

#include <stdlib.h>
#include <string.h>
#include <stdio.h>
#include <tos.h>
#include <aes.h>
#include <vdi.h>
#include <ext.h>
#include <math.h>

/***************
 * Konstanten: *
 ***************/

#define     FALSE       0               /* Boole'sche Werte         */
#define     TRUE        1

#define     HZ_200      0x4BA           /* Systemvariable           */

#define     MAX_STARS   100             /* Max- Zahl d. Sterne      */

#define     MAGIC       "SCHO"          /* Magic der CNF-Datei      */
#define     CNFNAME     "SCHONER.INF"   /* Filename fr CNF-Datei   */

/***********
 * Makros: *
 ***********/

#define     ABS(x)      ( ((x) > 0)   ? (x) : (-(x)) )
#define     MAX(x,y)    ( ((x) > (y)) ? (x) : (y) )
#define     MIN(x,y)    ( ((x) < (y)) ? (x) : (y) )

#define OBJ_PTR(object,item)    ((OBJECT*)&object[item])

/*******************
 * Eigene Includes *
 *******************/

#include "schoner.h"                /* Das Resource-File zum Programm   */
#include "resource.pro"             /* per externe Referenz.            */

/*********
 * Typen *
 *********/

typedef struct _APL_PAR         /* Gesammelte GEM-Applikationsparameter: */
{   int id,
        menu_id,
        phys_handle,
        virt_handle,
        p_wchar,
        p_hchar,
        p_wbox,
        p_hbox,
        x_auf,
        y_auf,
        n_planes;
    int work_in[11],
        work_out[57],
        msg[8];
} APL_PAR;

typedef struct      /* Ein "Stern" fr Warp8: */
{
    int     steps;  /* Wie "alt"?   */
    double  xpos;   /* Wo?          */
    double  ypos;
    int     size;   /* Wie "gro"?  */
} STAR;

typedef struct      /* Inhalt der Konfigurationsdatei: */
{
    char    magic[4];   /* Sollte "SCHO" sein   */
    int     on;         /* Eingeschaltet?       */
    int     verf;       /* Verfahren.           */
    long    minutes;    /* Schonzeit            */
} CONFIG;

/***********************
 * Externe Referenzen: *
 ***********************/

extern void init_trap(void);        /* In Ikbd und RS232 einklinken.    */
extern int  act_flag;               /* Hat sich was an Maus etc. getan? */

/*********************
 * Globale Variablen *
 *********************/

APL_PAR     aplpar;                 /* Gesammelte Applikationsparameter     */
int         virt_handle;            /* Globaler VDI-Handle fr RSC2CSRC     */
int         cb,ch;                  /* Breite und Hhe des Systemfonts      */
int         verfahren = WARP8;      /* Verfahren f. Schonung                */
int         aktiv = TRUE;           /* Schoner eingschaltet?                */
long        start_ticks = 0;        /* Start-200Hz-Ticks                    */
long        schon_zeit = 1;         /* Schonzeit in Minuten                 */

/***********************
 * Externe Referenzen: *
 ***********************/

extern      int     _app;           /* Sind wir ein Accessory? */

/*****************************************
 * ffnen einer Bildschirmarbeitsstation *
 * + universelle Alarmroutine (GEM)      *
 *****************************************/

void alert(char *msg, char *button)
{
    char    str[120];

    sprintf(str,"[1][%s][ %s ]",msg,button);
    form_alert(1,str);
}

int open_vwork(APL_PAR *ap_parm)
{
    int     i,dummy;

    if((ap_parm->id = appl_init()) != -1)
    {
        for(i = 1; i < 10; ap_parm->work_in[i++] = 0);
        ap_parm->work_in[10] = 2;
        ap_parm->phys_handle = graf_handle(&ap_parm->p_wchar, &ap_parm->p_hchar,
                                           &ap_parm->p_wbox, &ap_parm->p_hbox);
        cb=ap_parm->p_wchar;
        ch=ap_parm->p_hchar;
        ap_parm->work_in[0] = ap_parm->virt_handle = ap_parm->phys_handle;
        v_opnvwk(ap_parm->work_in, &ap_parm->virt_handle, ap_parm->work_out);
        virt_handle = ap_parm->virt_handle;
        ap_parm->x_auf = ap_parm->work_out[0];  /* Vorsicht: ist z.B. bei 640 nur 639!!! */
        ap_parm->y_auf = ap_parm->work_out[1];  /* Dito! */
        vq_extnd(ap_parm->virt_handle,1,ap_parm->work_out);
        graf_mouse(ARROW,0);
        ap_parm->n_planes = ap_parm->work_out[4];

        vst_alignment(ap_parm->virt_handle,0,5,&dummy,&dummy);
        vst_rotation(ap_parm->virt_handle,0);
        vst_color(ap_parm->virt_handle,1);
        vst_effects(ap_parm->virt_handle,0);

        /* Accessory? */
        if(!_app)
            ap_parm->menu_id = menu_register(ap_parm->id,"  Schoner 0.9");

        return(TRUE);
    }
    else
    {
        alert("Applikation kann nicht|angemeldet werden!?","Staun!?");
        return(FALSE);
    }
}

void close_vwork(APL_PAR *ap_parm)
{   v_clsvwk(ap_parm->virt_handle);                                             /* -> virtuelle Ausgabestation schlieen                    */
    if(!appl_exit())                                                            /* -> Anwendung abmelden                                    */
        alert("APPL_EXIT klappt nicht!?","Grunz!");
}

/******************************************
 * Ntzliche GEM-Funktionen und Parameter *
 ******************************************
 * (Wenn Atari wowas endlich mal ins GEM  *
 *  integrieren wrde! Grummel!!!)        *
 ******************************************/

int get_objflags(OBJECT *ob, int item)
{
     return(OBJ_PTR(ob,item)->ob_flags);
}

void set_objflags(OBJECT *ob, int item, int newflags)
{
     if(OBJ_PTR(ob,item)->ob_flags & LASTOB)
        newflags|=LASTOB;
     OBJ_PTR(ob,item)->ob_flags=newflags;
}

int get_objstate(OBJECT *ob, int item)
{
     return(OBJ_PTR(ob,item)->ob_state);
}

void set_objstate(OBJECT *ob, int item, int newstate)
{
     OBJ_PTR(ob,item)->ob_state=newstate;
}

void set_objselection(OBJECT *ob, int item, int flag)
{
     int    oldst;

     oldst=get_objstate(ob,item);
     set_objstate(ob,item,flag ? (oldst | SELECTED) : (oldst & ~SELECTED));
}

int object_selected(OBJECT *ob, int item)
{
     return (get_objstate(ob,item) & SELECTED) ? 1 : 0;
}

void set_objtext(OBJECT *ob, int item, char *s) /* Sollte sowieso im GEM drin sein :-((( */
{
     switch(ob[item].ob_type & 0xff)
     {
          case G_USERDEF    :   strcpy((char*)ob[item].ob_spec.userblk->ub_parm,s);
                                break;
          case G_TEXT       :
          case G_BOXTEXT    :
          case G_FTEXT      :
          case G_FBOXTEXT   :   strcpy(ob[item].ob_spec.tedinfo->te_ptext,s);
                                break;
          case G_BUTTON     :
          case G_STRING     :
          case G_TITLE      :   strcpy(ob[item].ob_spec.free_string,s);
                                break;
     }
}

char *get_objtext(OBJECT *ob, int item) /* Sollte auch im GEM drin sein :-((( */
{
     switch(ob[item].ob_type & 0xff)
     {
          case G_TEXT         :
          case G_BOXTEXT      :
          case G_FTEXT        :
          case G_FBOXTEXT     :    return (char*) ob[item].ob_spec.tedinfo->te_ptext;

          case G_BUTTON       :
          case G_STRING       :
          case G_TITLE        :    return (char*) ob[item].ob_spec.free_string;

          default             :    return ((void*)0);
     }
}

void get_dial_pos(OBJECT *dial, int *xd, int *yd)
{
     int  border,diff;

     objc_offset(dial,0,xd,yd);

     if(   (dial->ob_type & 0xff)==G_BOX
        || (dial->ob_type & 0xff)==G_IBOX
        || (dial->ob_type & 0xff)==G_BOXCHAR)
     {
          border = (int)((dial->ob_spec.index >> 16) & 0x00FFL);

          if(border & 0x0080) border |= 0xFF00;        /* Rand negativ */

          if(border<0)
          {
               *xd+=border;                            /* Wegen Rand */
               *yd+=border;
          }

          if(dial->ob_state & OUTLINED)                /* Outlined bercksichtigen */
          {
               if(border>=0)
                 diff=3;
               else
                 if(border>-3)
                   diff=3+border;
                 else
                   diff=0;

               *xd-=diff;                              /* Wegen Rand */
               *yd-=diff;
          }
     }
}

/***************************
 * 200Hz-Counter auslesen: *
 ***************************/

long get_200hz(void)
{
    long    ssp,ticks;

    ssp = Super((void*)0);      /* Supervisormode an        */
    ticks = *((long*) HZ_200);  /* 200Hz-Counter auslesen   */
    Super((void*)ssp);          /* Supervisormode aus       */
    return ticks;               /* Ticks liefern            */
}

/*********************************
 * Eine best. Zahl Ticks warten: *
 *********************************/

void wait_ticks(int n)
{
    long    start;

    start = get_200hz();
    while(get_200hz()-start < n);
}

/***************************************************
 * Feststellen, ob die Maus in einer "Spezialecke" *
 * des Schirms ist.                                *
 ***************************************************/

int mouse_always_sleep(int xauf, int yauf)
{
    int mx,my,button;

    /* Wo ist denn die Maus? */
    wind_update(BEG_MCTRL);
    vq_mouse(virt_handle,&button,&mx,&my);
    wind_update(END_MCTRL);

    /* Unten Rechts? */
    return (mx>xauf-3 && my>yauf-3);
}

int mouse_never_sleep(int yauf)
{
    int mx,my,button;

    /* Wo ist denn die Maus? */
    wind_update(BEG_MCTRL);
    vq_mouse(virt_handle,&button,&mx,&my);
    wind_update(END_MCTRL);

    /* Unten Links? */
    return (mx<3 && my>yauf-3);
}

/**************************************
 * Konfiguration speichern und laden: *
 **************************************/

int get_verf_nr(int verf)   /* Verfahren im RSC => 0..n-1 */
{
    switch(verf)    /* Welches Verfahren? */
    {
        case    PUZZLE  :   return 0;
        case    WARP8   :   return 1;
        default         :   return 0;   /* Unbekannt!? */
    }
}

void set_verf(int nr)   /* 0..n-1 => Verfahren im RSC */
{
    switch(nr)  /* Welches? */
    {
        case    0       :   verfahren = PUZZLE; break;
        case    1       :   verfahren = WARP8;  break;
        default         :   verfahren = WARP8;  break; /* Huch!? */
    }
}

void save_config(void)  /* Konfiguration speichern */
{
    int     fh;
    CONFIG  cnf;

    /* Konfigurationsstruktur belegen:                  */
    memcpy(&cnf.magic,MAGIC,4);         /* Magic                */
    cnf.on = aktiv;                     /* Aktiv                */
    cnf.minutes = schon_zeit;           /* Schonzeit in Minuten */
    cnf.verf = get_verf_nr(verfahren);  /* Verfahren            */

    /* Neue Datei anlegen: */
    if((fh = (int)Fcreate(CNFNAME,0)) < 0)
    {
        alert("Konfigurationsdatei konnte nicht | erzeugt werden!","Mist!");
        return;
    }

    /* Inhalt schreiben: */
    if(Fwrite(fh,sizeof(CONFIG),&cnf) != sizeof(CONFIG))
    {
        alert("Schreibfehler beim Anlegen der | Konfiguration!","Shit!");
        Fclose(fh);
        return;
    }

    Fclose(fh); /* Datei wieder dicht machen und fertig! */
}

void set_dialog_to_default(void)    /* Dialog passend zu d. Einstellungen setzen: */
{
    char    str[5];

    set_objselection(TREE[MAINDIAL],PUZZLE,FALSE);
    set_objselection(TREE[MAINDIAL],WARP8,FALSE);
    set_objselection(TREE[MAINDIAL],verfahren,TRUE);
    sprintf(str,"%02ld",schon_zeit);
    set_objtext(TREE[MAINDIAL],MINUTES,str);
}

void load_config(void)  /* Konfiguration laden: */
{
    int     fh;
    CONFIG  cnf;

    /* Datei lesen: */
    if((fh = (int)Fopen(CNFNAME,0)) < 0)
        return; /* War halt keine da... */

    /* Laden... */
    if(Fread(fh,sizeof(CONFIG),&cnf) != sizeof(CONFIG))
    {
        /* Lesefehler!? */
        Fclose(fh);
        return;
    }

    /* Schlieen: */
    Fclose(fh);

    /* Sieht das brauchbar aus? */
    if(memcmp(&cnf.magic,MAGIC,4) != 0)
        return; /* Nein! Kein Magic => ignorieren! */

    /* Ja: Inhalt bernehmen: */
    aktiv = cnf.on;                     /* Aktiv?       */
    schon_zeit = MAX(1,cnf.minutes);    /* Schonzeit    */
    set_verf(cnf.verf);                 /* Verfahren    */

    set_dialog_to_default();            /* Einstellungen auch im Dialog */
}

/***********************************************
 * Zeigt und bearbeitet die Schoner-Dialogbox: *
 ***********************************************/

void doit_all(void)
{
    GRECT   clip;
    int     exit;

    wind_update(BEG_UPDATE);    /* Schirm gehrt mir! */

    /* Dialog erscheinen lassen: */
    form_center(TREE[MAINDIAL],&clip.g_x,&clip.g_y,&clip.g_w,&clip.g_h);
    form_dial(FMD_START,0,0,0,0,clip.g_x,clip.g_y,clip.g_w,clip.g_h);
    form_dial(FMD_GROW,0,0,0,0,clip.g_x,clip.g_y,clip.g_w,clip.g_h);
    objc_draw(TREE[MAINDIAL],ROOT,MAX_DEPTH,clip.g_x,clip.g_y,clip.g_w,clip.g_h);

    do  /* Auf Klicks im Dialog warten... */
    {
        exit=form_do(TREE[MAINDIAL],0);   /* Auf Mausklick in Box warten  */

        /* Dialogposition wg. "Let them fly!" neu ermitteln: */
        get_dial_pos(TREE[MAINDIAL],&clip.g_x,&clip.g_y);

        switch(exit)    /* Was darf's denn sein? */
        {
            case    SON     :   /* Aktivieren */
                                aktiv = TRUE;
                                break;

            case    SOFF    :   /* Deaktivieren */
                                aktiv = FALSE;
                                break;

            /* Eigene Verfahren mssen HIER drunter auch stehen! */

            case    PUZZLE  :   /* Verfahren setzen: */
            case    WARP8   :   verfahren = exit;
                                break;

            case    SAVECNF :   /* Konfig. speichern: */
                                save_config();
                                set_objselection(TREE[MAINDIAL],SAVECNF,0);
                                objc_draw(TREE[MAINDIAL],SAVECNF,MAX_DEPTH,
                                          clip.g_x,clip.g_y,clip.g_w,clip.g_h);
                                break;
        }
    } while (exit!=SON && exit!=SOFF);  /* Bis an oder aus angewhlt ist */

    /* Dialog wieder verschwinden lassen: */
    form_dial(FMD_FINISH,0,0,0,0,clip.g_x,clip.g_y,clip.g_w,clip.g_h);
    form_dial(FMD_SHRINK,0,0,0,0,clip.g_x,clip.g_y,clip.g_w,clip.g_h);

    wind_update(END_UPDATE);    /* Schirm ist nun wieder "PD" ;-) */

    /* An oder Aus? Egal! Auf jeden Fall wieder den Button deselektieren!: */
    set_objselection(TREE[MAINDIAL],exit,0);    /* Exit deselektieren */

    /* Ggf. die Schonzeit aus dem Dialog bernehmen: */
    if(exit == SON)
    {
        /* "Tierisches Konstrukt", schon klar... :-))) */
        sscanf(get_objtext(TREE[MAINDIAL],MINUTES),"%ld",&schon_zeit);
        schon_zeit = MAX(1,schon_zeit); /* Mindestens 1 Minute! */
    }
}

/*********************************************
 * Bildschirmschonung ist angesagt (Puzzle): *
 *********************************************/

int sgn(int x)  /* Signum-Funktion (hat nix mit der Textverarbeitung zu tun) ;-) */
{
    if(x == 0)
        return 0;
    else
        if(x < 0)
            return -1;
        else
            return 1;
}

int calc_ggt(int a, int b)  /* Der Algorithmus vom alten Griechen... */
{
    /* Ende der Rekursion? */
    if(a == b)
        return a;   /* Ggt von zwei gleichen Zahlen ist klar! */

    /* Nein! Einen Level weiter runter... */
    if(a > b)
        return calc_ggt(a-b,b); /* Nanu!? Wir rufen das Unterprogramm auf, ... */
    else
        return calc_ggt(a,b-a); /* ... ohne da wir damit fertig sind!?        */
}                               /* (Informatikprofessor an der Uni KL)         */

int finde_quadrat_teilung(int xauf, int yauf, int *hanz, int *vanz)
{
    int     ggt,numx,numy,kantx,kanty;

    ggt = calc_ggt(xauf,yauf);  /* Ggt nach Euklid. Oder wer war das noch? */
    numx = xauf / ggt;  /* Zahl d. horiz. Quadrate  */
    numy = yauf / ggt;  /* Zahl d. vertik. Quadrate */

    /* Stcke zu gro? */
    if(numx<5 || numy<5)
    {
        /* Jedes Stck nach Mgl. noch einmal halbieren: */
        kantx = xauf / numx;    /* Lnge einer Quadratkante...  */
        kanty = yauf / numy;    /* ... in Pixel.                */
        while(numx<16 && numy<16 && (kantx%2==0) && (kanty%2==0))
        {
            numx  *= 2; /* Zahl der Kstchen * 2...     */
            numy  *= 2;
            kantx /= 2; /* ...dafr die Gre durch 2   */
            kanty /= 2;
        }

        /* Stcke immer noch zu gro? */
        if(numx<5 || numy<5)
            return FALSE;   /* Da ist nix zu machen! */
    }

    /* Stcke zu klein? */
    if(numx>16 || numy>16)
        return FALSE;       /* Nix zu machen! */

    /* Berechnete Stckanzahlen liefern: */
    *hanz = numx;
    *vanz = numy;
    return TRUE;    /* Fertig. H h h... */
}

int finde_schirm_teilung(int xauf, int yauf, int *hanz, int *vanz)
{
    int     i;
    int     tip[] = { 10,9,11,8,12,7,13,6,14,5,15,4,16 }; /* f. Teilersuche */

    /* Ist das ein TT-Gromoni mit 1280*960? */
    if(xauf==1280 && yauf==960)
    {
        /* Ist einfach auf dem TT-Gromoni schner, oder? */
        *hanz = 8;
        *vanz = 6;
        return TRUE;
    }

    /* Finde quadratische Aufteilung, falls mglich: */
    if(finde_quadrat_teilung(xauf,yauf, hanz, vanz))
        return TRUE;    /* Quadratisch geht => die nehmen! */

    /************************************************************************
    * Quadratisch geht hier nicht! Staun! Na gut:                           *
    *************************************************************************
    * Fr "obskure" Auflsungen dann eben diese Methode anwenden:           *
    * (Sucht in best. Reihenfolge die Zahlen von 4-16 als Kstchenzahl ab)  *
    *************************************************************************/

    /* Unterteilung fr die horizontalen Kstchen mglich? */
    for(i=0,*hanz=tip[i]; i<(int)sizeof(tip)/sizeof(int) && *hanz!=0 && (xauf%(*hanz)!=0); (*hanz)=tip[i++]);
    if(i >= (int)sizeof(tip)/sizeof(int))
        return FALSE;   /* Nix gefunden! */

    /* Unterteilung fr die vertikalen Kstchen mglich? */
    for(i=0,*vanz=tip[i]; i<(int)sizeof(tip)/sizeof(int) && *vanz!=0 && (yauf%(*vanz)!=0); (*vanz)=tip[i++]);
    if(i >= (int)sizeof(tip)/sizeof(int))
        return FALSE;   /* Nix gefunden! */

    return TRUE;        /* Erfolg! */
}

int calc_fpos(int aufl, int teile, int n_teil)  /* Aufteilung d. Felder */
{
    int erg;

    erg = (aufl / teile) * n_teil;
    return erg;
}

void draw_fields(int xauf, int yauf, int hanz, int vanz)    /* Feldaufteilung mit Linien */
{
    int i,k,pxy[10];

    vsl_color(virt_handle,1);           /* Bitte schwarze Linien! */
    vswr_mode(virt_handle,MD_REPLACE);  /* Replace                */
    vsl_type(virt_handle,1);            /* Duchgezogen            */
    vsl_width(virt_handle,1);           /* Dicke 1                */

    for(i=0; i<hanz && !act_flag; i++)
        for(k=0; k<vanz && !act_flag; k++)
        {
            /* Koordinaten fr "v_pline" setzen: */
            pxy[0] = calc_fpos(xauf,hanz,i);  /* Links oben */
            pxy[1] = calc_fpos(yauf,vanz,k);
            pxy[2] = calc_fpos(xauf,hanz,i);  /* Links unten */
            pxy[3] = calc_fpos(yauf,vanz,k+1);
            pxy[4] = calc_fpos(xauf,hanz,i+1);/* Rechts unten */
            pxy[5] = calc_fpos(yauf,vanz,k+1);
            pxy[6] = calc_fpos(xauf,hanz,i+1);/* Rechts oben */
            pxy[7] = calc_fpos(yauf,vanz,k);
            pxy[8] = calc_fpos(xauf,hanz,i);  /* Wieder links oben */
            pxy[9] = calc_fpos(yauf,vanz,k);
            v_pline(virt_handle,5,pxy); /* Polylinie ziehen */
        }
}

void erase_field(int xauf, int yauf, int hanz, int vanz, int px, int py)    /* Startfeld lschen */
{
    int     i,fsize,pxy[10];

    fsize = MAX(xauf/hanz,yauf/vanz);    /* Anzahl der Pixel/Feld */

    /* Koordinaten fr "v_pline" setzen: */
    pxy[0] = calc_fpos(xauf,hanz,px);   /* Links oben */
    pxy[1] = calc_fpos(yauf,vanz,py);
    pxy[2] = calc_fpos(xauf,hanz,px);   /* Links unten */
    pxy[3] = calc_fpos(yauf,vanz,py+1);
    pxy[4] = calc_fpos(xauf,hanz,px+1); /* Rechts unten */
    pxy[5] = calc_fpos(yauf,vanz,py+1);
    pxy[6] = calc_fpos(xauf,hanz,px+1); /* Rechts oben */
    pxy[7] = calc_fpos(yauf,vanz,py);
    pxy[8] = calc_fpos(xauf,hanz,px);   /* Wieder Links oben */
    pxy[9] = calc_fpos(yauf,vanz,py);

    /* Immer kleinere Quadrate nzw. Rechtecke zeichen: */
    for(i=0; i<fsize && i<xauf/hanz && i<yauf/vanz && !act_flag; i++)
    {
            pxy[0]++; pxy[1]++;     /* Linke obere Ecke verkleinern */
            pxy[2]++; pxy[3]--;     /* Linke untere Ecke            */
            pxy[4]--; pxy[5]--;    /* Rechte untere Ecke           */
            pxy[6]--; pxy[7]++;     /* Rechte obere Ecke            */
            pxy[8]++; pxy[9]++;     /* Wieder linke obere Ecke      */
            v_pline(virt_handle,5,pxy); /* Polylinie ziehen         */
            Vsync();                /* 1 Bildschirmaufbau warten    */
    }
}

void calc_richtung(int dir, int *dx, int *dy)   /* Berechnet dx und dy f. Richtung */
{
    switch(dir)       /* Welche Richtung soll's denn sein?    */
    {
        case    0   :   *dx = 1;  *dy = 0;  break;  /* Rechts   */
        case    1   :   *dx = 0;  *dy = -1; break;  /* Oben     */
        case    2   :   *dx = -1; *dy = 0;  break;  /* Links    */
        case    3   :   *dx = 0;  *dy = 1;  break;  /* Unten    */

        default     :   *dx = 1;  *dy = 0;  break;  /* Rechts   */
    }
}

void calc_new_position(long field[16][16], int hanz, int vanz, int *last_px, int *last_py, int *px, int *py)
{
    int     i,dx,dy,npx,npy,dir;
    long    dist[4],max_val;

    /* Per Zufall eine neue Richtung suchen: */
    do
    {
        if(random(5) > 2)   /* Welche "Verschiebestrategie"? */
        {
            /* Zufllige Richtung nehmen: */
            calc_richtung(random(4),&dx,&dy); /* Richtung bestimmen       */
            npx = *px + dx;         /* Neue Versuchsposition    */
            npy = *py + dy;
        }
        else
        {
            /* Bestimmte Richtung (nach Schiebehufigkeit) nehmen: */
            max_val = 0x7FFFFFFFFL;
            for(i=0; i<4; i++)  /* Alle Richtungen probieren... */
            {
                calc_richtung(i,&dx,&dy);   /* i. Richtung */
                npx = *px + dx;
                npy = *py + dy;

                /* Neue Position: */
                if(npx<0 || npx>=hanz || npy<0 || npy>=vanz)
                    dist[i] = 0x7FFFFFFFL;  /* Illegal! */
                else
                    dist[i] = field[npx][npy];  /* Anzahl aus Karte */

                /* "Besser"? */
                if(dist[i] < max_val)
                {
                    max_val = dist[i];  /* Ja, merken! */
                    dir = i;
                }
            }

            /* Aus neuer Richtung neue Position errechnen: */
            calc_richtung(dir,&dx,&dy);
            npx = *px + dx;
            npy = *py + dy;
        }

    /* Solange die neue Position illegal ist */
    } while((npx==*last_px && npy==*last_py) ||         /* Gleiche Pos. */
            npx<0 || npy<0 || npx>=hanz || npy>=vanz);  /* Illegal      */

    /* Neue Werte bernehmen und fertig: */
    *last_px = *px;
    *last_py = *py;
    *px = npx;
    *py = npy;
}

void copy_from_to(int sx, int sy, int dx, int dy, int breite, int hoehe)
{
    MFDB    s,d;
    int     mode,pxy[8];

    s.fd_addr    = NULL;            /* Schirm. Macht das VDI    */
    s.fd_w       = breite;          /* Blockbreite              */
    s.fd_h       = hoehe;           /* Blockhhe                */
    s.fd_wdwidth = (breite+15) / 2; /* Breite in Words          */
    s.fd_stand   = 0;               /* Gerteabhngiges Format  */
    memcpy(&d,&s,sizeof(MFDB));     /* Ziel-MFDB ist indentisch */

    pxy[0] = sx;
    pxy[1] = sy;
    pxy[2] = sx + breite - 1;
    pxy[3] = sy + hoehe - 1;
    pxy[4] = dx;
    pxy[5] = dy;
    pxy[6] = dx + breite - 1;
    pxy[7] = dy + hoehe - 1;
    mode = S_ONLY;  /* Replace-Mode */
    vro_cpyfm(virt_handle,mode,pxy,&s,&d);  /* Kopieren */
}

void draw_rect(int x, int y, int b, int h)  /* Leeres Rechteck */
{
    int pxy[10];

    vsl_color(virt_handle,1);           /* Bitte schwarze Linien! */
    vswr_mode(virt_handle,MD_REPLACE);  /* Replace                */
    vsl_type(virt_handle,1);            /* Duchgezogen            */
    vsl_width(virt_handle,1);           /* Dicke 1                */

    pxy[0] = x;         /* LO */
    pxy[1] = y;
    pxy[2] = x;         /* LU */
    pxy[3] = y + h ;
    pxy[4] = x + b ;    /* RU */
    pxy[5] = y + h ;
    pxy[6] = x + b ;    /* RO */
    pxy[7] = y;
    pxy[8] = x;         /* LO */
    pxy[9] = y;
    v_pline(virt_handle,5,pxy);
}

/* Ein Kltzchen langsam verschieben: */
void move_block(int xauf, int yauf, int hanz, int vanz, int last_px, int last_py, int px, int py)
{
    int i,breite,hoehe,sx,sy,ex,ey,dx,dy;
    int rx,ry;

    /* Breite und Hhe errechnen: */
    breite = xauf / hanz;
    hoehe  = yauf / vanz;

    /* Positionen errechnen: */
    sx = calc_fpos(xauf,hanz,px);
    sy = calc_fpos(yauf,vanz,py);
    ex = calc_fpos(xauf,hanz,last_px);
    ey = calc_fpos(yauf,vanz,last_py);

    rx = ex - sx;   /* X-Differenz      */
    ry = ey - sy;   /* Y-Differenz      */
    dx = sgn(rx);   /* Richtung in x    */
    dy = sgn(ry);   /* Richtung in y    */

    /* Alle Pixel verschieben: */
    for(i=0; i<(ABS(rx)+ABS(ry)) && !act_flag; i++)
    {
        /* 1 Pixel verschieben: */
        draw_rect(sx,sy,breite,hoehe);
        copy_from_to(sx+1,sy+1,sx+dx+1,sy+dy+1,breite-1,hoehe-1);
        sx += dx;
        sy += dy;
        draw_rect(sx,sy,breite,hoehe);
        wait_ticks(1);  /* Mind 1/200 Sec. warten */
    }
}

int do_puzzling(int xauf, int yauf)  /* Bildschirmpuzzle... */
{
    int     i,k,hanz,vanz,pix[4];
    int     last_px,last_py,px,py;
    long    field[16][16];

    /* VDI-Krams initialisieren: */
    pix[0] = pix[1] = 0;
    pix[2] = xauf - 1;
    pix[3] = yauf - 1;
    vs_clip(virt_handle,TRUE,pix);      /* Bitte nur in den Schirm malen! */

    /* Nun eine "brauchbare" Aufteilung des Schirms errechnen: */
    if(!finde_schirm_teilung(xauf,yauf,&hanz,&vanz))
    {
        /* Booooh Ey! Mann Ey! Das gibt's auch!?
           Wegen seltsamer Schirmauflsung kann das
           Puzzle nicht verwendet werden! */
        return FALSE;   /* So hat's nunmal keinen Sinn! */
    }

    /* Felder mit schwarzen Linien abgrenzen: */
    draw_fields(xauf,yauf,hanz,vanz);

    /* Karte leeren: */
    for(i=0; i<hanz; i++)
        for(k=0; k<vanz; k++)
            field[i][k] = 0L;

    /* Startposition innerhalb des Feldes per Zufall festlegen: */
    last_px = px = random(hanz);
    last_py = py = random(vanz);

    field[px][py]++;    /* Anwesenheit merken */

    /* Startfeld schwarz frben: */
    erase_field(xauf,yauf,hanz,vanz,px,py);

    /* Krftig puzzeln: */
    while(!act_flag)
    {
        calc_new_position(field,hanz,vanz,&last_px,&last_py,&px,&py); /* Neue Richtung */
        move_block(xauf,yauf,hanz,vanz,last_px,last_py,px,py);  /* Block bewegen */
        field[px][py]++;    /* Anwesenheit "merken" */
    }

    return TRUE;    /* Hat prima geklappt. */
}

/*********************************************
 * Bildschirmschonung ist angesagt (Warp 8): *
 *********************************************/

void make_new_star(int xauf, int yauf, STAR *star)  /* Stern initialisieren */
{
    int dx,dy;

    /* Zufallszahlen fr die Position ermitteln: */
    dx = random(120) - 60;  /* So etwa in der Schirmmitte */
    dy = random(120) - 60;

    /* Werte des Sterns setzen: */
    star->steps = 0;
    star->size = 1;
    star->xpos = (xauf / 2) + dx;
    star->ypos = (yauf / 2) + dy;
}

void move_star(int xauf, int yauf, STAR *star)  /* Stern fliegen lassen... */
{
    int     midx,midy;
    double  step;

    star->steps++;

    if((star->steps & 0x3)==0 && star->steps>4)
    {
        if(star->size > 3)
            star->size *= 2;
        else
            star->size++;
    }

    /* Bewegen... */
    midx = xauf / 2;
    midy = yauf / 2;
    step = sqrt((double)star->steps) + 10.0;
    star->xpos += ((double)(star->xpos - midx) * (double)step) / 50.0;
    star->ypos += ((double)(star->ypos - midy) * (double)step) / 50.0;

    /* Wird er dann zur "Leiche"? */
    if(star->xpos<=0.0 || star->ypos<=0.0 ||
       star->xpos>=xauf || star->ypos>=yauf ||
       star->steps>30)
    {
        star->steps = -1;   /* "Tot"! */
    }
}

void draw_circle(int x, int y, int size, int color) /* Kreis bzw. Punkt */
{
    int pix[4];

    /* Lohnt sich ein Kreis? */
    if(size > 1)
    {
        /* Ja: */
        vsf_color(virt_handle,color);
        v_circle(virt_handle,x,y,size);
    }
    else
    {
        /* Nein: Punkt! Geht _viel_ schneller... */
        vsl_color(virt_handle,color);   /* Linienfarbe setzen */
        pix[0] = pix[2] = x;
        pix[1] = pix[3] = y;
        v_pline(virt_handle,2,pix);     /* Linie "auf sich selbst" */
    }
}

void draw_star(int xauf, int yauf, STAR *star)  /* Stern hinmalen */
{
    int delta_x,delta_y;

    if(star->steps >= 0)
    {
        delta_x = star->xpos - (xauf/2);
        delta_y = star->ypos - (yauf/2);
        if(ABS(delta_x)>20 && ABS(delta_y)>20)
            draw_circle((int)star->xpos,(int)star->ypos,star->size,0);
    }
}

void undraw_star(int xauf, int yauf, STAR *star)    /* Stern wegmalen */
{
    int delta_x,delta_y;

    if(star->steps >= 0)
    {
        delta_x = star->xpos - (xauf/2);
        delta_y = star->ypos - (yauf/2);
        if(ABS(delta_x)+ABS(delta_y)>40)
            draw_circle((int)star->xpos,(int)star->ypos,star->size,1);
    }
}

void do_warp8(int xauf, int yauf, int num_stars)    /* Stars, stars, stars... */
{
    int     i,pix[4];
    STAR    stars[MAX_STARS];
    long    timer;

    /* Sichergehen, da wir mit einer "vernnftigen" Zahl Sterne arbeiten: */
    num_stars = MAX(1,num_stars);
    num_stars = MIN(MAX_STARS,num_stars);

    /* VDI-Krams initialisieren: */
    pix[0] = pix[1] = 0;
    pix[2] = xauf - 1;
    pix[3] = yauf - 1;
    vs_clip(virt_handle,TRUE,pix);      /* Bitte nur in den Schirm malen! */
    vswr_mode(virt_handle,MD_REPLACE);  /* Replace */
    vsf_interior(virt_handle,FIS_SOLID);/* Gefllt ohne Muster */

    /* Zuerst einmal den ganzen Schirm leeren...*/
    pix[0] = pix[1] = 0;
    pix[2] = xauf;
    pix[3] = yauf;
    vsf_color(virt_handle,1);
    v_bar(virt_handle,pix);         /* Au weia! Ist das finster...! */

    /* Sternchen initialisieren: */
    for(i=0; i<num_stars && !act_flag; i++)
        make_new_star(xauf,yauf,&stars[i]);   /* Neuen Stern machen */

    /* Sternchen weiterrcken: */
    timer = get_200hz();    /* f. Stern-"Vorlauf"           */
    while(!act_flag)        /* So lange der User nix macht  */
    {
        for(i=0; i<num_stars && !act_flag; i++)/* Alle Sternchen abklappern... */
        {
            /* Vorhandener Stern? */
            if(stars[i].steps >= 0)
            {
                /* Unsichtbarer Vorlauf? */
                if(get_200hz()-timer<200 && stars[i].steps<10)
                    move_star(xauf,yauf,&stars[i]);   /* nur bewegen */
                else
                {
                    /* Sichtbarer Lauf: */
                    undraw_star(xauf,yauf,&stars[i]); /* Stern lschen */
                    move_star(xauf,yauf,&stars[i]);   /* bewegen */
                    draw_star(xauf,yauf,&stars[i]);   /* neuzeichnen */
                }
            }
            else
            {
                /* Nein! Neuen Stern machen: */
                make_new_star(xauf,yauf,&stars[i]);   /* Neuen Stern machen   */
            }   /* Else */
        }   /* For */
    }   /* While */
}

/**************************
 * Haupt-Schonroutine(n): *
 **************************/

long calc_buf_ram(int breite, int hoehe, int planes)    /* Ber. d. Puffergre */
{
    long    words_p_line;

    words_p_line = ((long)breite + 15L) / 2L;               /* Words/Zeile und Plane    */
    return words_p_line * (long)hoehe * (long)planes * 2L;  /* Bytes insgesamt          */
}

void get_menu_size(int xauf, int yauf, int *width, int *height) /* Gre d. Menues ermitteln: */
{
    int wx,wy,ww,wh;

    wind_get(0,WF_WORKXYWH,&wx,&wy,&ww,&wh);/* Gre d. Hintergrundes minus         */
    *height = yauf - wh + 1;                /* der Hhe des Schirms => Hhe         */
    *width  = xauf;         /* Menues gehen in der Breite ber den ganzen Schirm    */
}

void copy_raster(char *sbuf, char *dbuf, int breite, int hoehe, int planes)
{
    MFDB    s,d;
    int     mode,pxy[8];

    /* MFDBs belegen: */
    s.fd_addr    = sbuf;            /* Schirm. Macht ggf. das VDI       */
    s.fd_w       = breite;          /* Blockbreite                      */
    s.fd_h       = hoehe;           /* Blockhhe                        */
    s.fd_wdwidth = (breite+15) / 2; /* Breite in Words                  */
    s.fd_stand   = 0;               /* Gerteabhngiges Format          */
    s.fd_nplanes = planes;          /* Planezahl                        */

    memcpy(&d,&s,sizeof(MFDB));     /* Ziel-MFDB ist i.w. indentisch    */
    d.fd_addr    = dbuf;            /* Macht ggf. das VDI               */

    pxy[0] = 0;
    pxy[1] = 0;
    pxy[2] = breite - 1;
    pxy[3] = hoehe - 1;
    pxy[4] = 0;
    pxy[5] = 0;
    pxy[6] = breite - 1;
    pxy[7] = hoehe - 1;
    mode = S_ONLY;  /* Replace-Mode */
    vro_cpyfm(virt_handle,mode,pxy,&s,&d);  /* VDI: Kopieren */
}

char *save_menu_line(int xauf, int yauf, int planes)    /* Menuzeile merken */
{
    long    ram;
    char    *buf;
    int     mwidth,mheight;

    /* Feststellen, wie gro die Menuezeile ist: */
    get_menu_size(xauf,yauf,&mwidth,&mheight);

    /* Speicher f. Menuezeile berechnen und reservieren: */
    ram = calc_buf_ram(mwidth,mheight,planes);
    if((buf=malloc(ram)) == NULL)
        return NULL;    /* Tja! Kein Speicher da! */

    /* Menuezeile per VDI kopieren: */
    copy_raster(NULL,buf,mwidth,mheight,planes);

    return buf; /* Erfolg! Hier ist der Puffer. */
}

void restore_menu_line(int xauf, int yauf, int planes, char *buf)   /* Menuezeile restaurieren */
{
    int mwidth,mheight;

    /* War berhaupt ein Puffer restauriert worden? */
    if(buf == NULL)
        return; /* Kann passieren, wenn kein Speicher da ist!!! */

    /* Feststellen, wie gro die Menuezeile ist: */
    get_menu_size(xauf,yauf,&mwidth,&mheight);

    /* Menuezeile per VDI restaurieren: */
    copy_raster(buf,NULL,mwidth,mheight,planes);
}

void schone_mal(void)   /* Schon-Verteilerroutine: */
{
    char    *buf;

    /* Zuerst einmal die Maus aus und die Bildschirmkontrolle holen: */
    graf_mouse(M_OFF,NULL);     /* Aus die Maus!        */
    wind_update(BEG_UPDATE);    /* Mein ist der Schirm! */
    form_dial(FMD_START,0,0,0,0,0,0,aplpar.x_auf,aplpar.y_auf);

    /* Nun die Menuezeile zwischenspeichern: */
    buf = save_menu_line(aplpar.x_auf+1,aplpar.y_auf+1,aplpar.n_planes);

    /* Wer mag, knnte hier auch per Zufall eins auswhlen. Lohnt sich
       aber natrlich nur, wenn man wirklich viele htte ;-) */

    switch(verfahren)   /* Welche Schonung ist angesagt? */
    {
        case    PUZZLE  :   /* Puzzle => Was fr Fans von Geduldsspielen... */
                            if(!do_puzzling(aplpar.x_auf+1,aplpar.y_auf+1))
                                do_warp8(aplpar.x_auf+1,aplpar.y_auf+1,50);
                            break;

        case    WARP8   :   /* Warp 8 => Aha! Ein Treckkie! */
                            do_warp8(aplpar.x_auf+1,aplpar.y_auf+1,50);
                            break;

        default :   return; /* H!? Das kann ich nicht!!! */

        /* Eigene Schoner knnte man hier oben prima einklinken. Die sollten
           aber natrlich _sofort_ zurckkehren, falls act_flag=TRUE ist! */
    }

    /* Fertig! Menuezeile wieder restaurieren: */
    restore_menu_line(aplpar.x_auf+1,aplpar.y_auf+1,aplpar.n_planes,buf);
    free(buf);	/* Puffer auch wieder freigeben wr' nicht schlecht! */

    /* Maus wieder an , Redraw auslsen und Bildschirm freigeben: */
    form_dial(FMD_FINISH,0,0,0,0,0,0,aplpar.x_auf+1,aplpar.y_auf+1);    /* Redraw! */
    wind_update(END_UPDATE);    /* Schirmkontrolle abgegeben */
    graf_mouse(M_ON,NULL);      /* Wieder krftig rummausen! */
}

/******************
 * Event-Schleife *
 ******************/

void event_loop(void)   /* Horch was kommt von drauen rein, hollahi... */
{
    int     x,y,kstate,
            key,clicks,
            event,state;
    int     pipe[8];

   do
   {
        /* Das AES schn immer ansprechen und in Trab halten ;-) */
        event = evnt_multi( MU_MESAG | MU_TIMER,
                          2, 0x1, 1,
                          0, 0, 0, 0, 0,
                          0, 0, 0, 0, 0,
                          pipe,
                          1000, 0,   /* (=1s-Timer) */
                          &x, &y, &state, &kstate, &key, &clicks );

        /* Herr Postbote: Ist denn endlich was fr mich dabei? */
        if(event&MU_MESAG && pipe[0]==AC_OPEN && pipe[4]==aplpar.menu_id)
        {
                doit_all();                 /* Dialog abarbeiten    */
                start_ticks = get_200hz();  /* Start-Ticks merken   */
        }   /* Message */

        /* As time goes by... */
        if(event & MU_TIMER)
        {
            /* Timer-Event ist da: */
            if(act_flag || mouse_never_sleep(aplpar.y_auf))
            {
                /* Aktion ist aufgetreten: */
                start_ticks = get_200hz();  /* Start-Ticks merken   */
                act_flag = FALSE;           /* Flag rcksetzen      */
            }
            else
            {
                /* Keine Aktion da: */
                if(((get_200hz()-start_ticks>200L*60L*schon_zeit)
                    || mouse_always_sleep(aplpar.x_auf,aplpar.y_auf)) && aktiv)
                {
                    /* Schonen ist nun angesagt: */
                    schone_mal();   /* Kehrt zurck falls act_flag=TRUE */
                }
            }
        }   /* Timer */
   } while(TRUE); /* Accessories sind immer im Dienst. Scheijob! */
}

/******************
 * Hauptprogramm: *
 ******************/

int main(void)
{
    if(open_vwork(&aplpar))     /* Los gehts!?                  */
    {
        fix_koordinates();
        objc_init();            /* Resource anpassen            */
        init_userdefs();        /* Radiobuttons etc.            */
        load_config();          /* Konfiguration ggf. lesen     */
        set_dialog_to_default();/* Einstellungen auch im Dialog */
        if(!_app)               /* Accessory?                   */
        {
            init_trap();        /* Ja: Trap-Handler einklinken  */
            act_flag = FALSE;   /* Nicht direkt losschonen!     */
            start_ticks = get_200hz();  /* Start-Ticks merken   */
            event_loop();       /* und in die Event-Loop        */
        }
        else
            alert("Schoner 0.9 luft nur | als Accessory!","Isjagut!");

        forget_userdefs();
        close_vwork(&aplpar);   /* Feierabend!              */
    }
    return 0;
}

/**********************
 * This is the end... *
 **********************
 * (J. Morrison)      *
 **********************/

