/*************************************************************
*                                                            *
*           Projekt         :    FANTASY.AAS                 *
*                                                            *
*           Datei           :   FANT_AAS.H                   *
*           erster Pixel    :    0. 0.   0                   *
*           letzte nderung :   24.11.1992                   *
*                                                            *
*************************************************************/


/*----------------- Konstanten -----------------------------*/
#define		ICONS_PER_ROW_MAX	256

enum	{
			16_PIXEL_ICONS,
			32_PIXEL_ICONS,
			64_PIXEL_ICONS,

			ICON_ROWS_MAX
		};


/*-----------------	Strukturen -----------------------------*/
typedef struct	{
					WORD		x;
					WORD		y;
				}
				HLOC;

typedef struct	{
					char		name[20];
					WORD		width;
					WORD		height;

					HLOC		loc[ICONS_PER_ROW_MAX];
				}
				HAAS;

typedef struct	{
					char		name[16];
					int			row_amount;

					HROW		row[ICON_ROWS_MAX];
				}
				HAAS;


/*-----------------	Daten ----------------------------------*/
HAAS	haas =
{
	"FANTASY.AAS",
	3,
	{
		"16_PIXEL_ICONS",
		16,16,
		{
			{0,0},
			{16,0},
			{32,0},
			{48,0},
			{64,0},
			{80,0},
			{96,0},
			{112,0},
			{128,0},
			{144,0},
			{160,0},
			{176,0},
			{192,0},
			{208,0},
			{224,0},
			{240,0}
		}
	},
	{
		"32_PIXEL_ICONS",
		32,32,
		{
			{0,16},
			{32,16},
			{64,16},
			{96,16},
			{128,16},
			{160,16},
			{192,16},
			{224,16},
			{256,16},
			{288,16},
			{320,16},
			{352,16},
			{384,16},
			{416,16},
			{448,16},
			{480,16}
		}
	},
	{
		"64_PIXEL_ICONS",
		64,64,
		{
			{0,48},
			{64,48},
			{128,48},
			{192,48},
			{256,48},
			{320,48},
			{384,48},
			{448,48}
		}
	}
};


