/*************************************************************
*                                                            *
*           Projekt         :     SCHIFF.AAS                 *
*                                                            *
*           Datei           :   SCHI_AAS.H                   *
*           erster Pixel    :   24.11.1992                   *
*           letzte nderung :   24.11.1992                   *
*                                                            *
*************************************************************/


/*----------------- Konstanten -----------------------------*/
#define		ICONS_PER_ROW_MAX	256

enum	{
			LINIENSCHIFF,

			ICON_ROWS_MAX
		};


/*-----------------	Strukturen -----------------------------*/
typedef struct	{
					WORD		x;
					WORD		y;
				}
				HLOC;

typedef struct	{
					char		name[20];
					WORD		width;
					WORD		height;

					HLOC		loc[ICONS_PER_ROW_MAX];
				}
				HAAS;

typedef struct	{
					char		name[16];
					int			row_amount;

					HROW		row[ICON_ROWS_MAX];
				}
				HAAS;


/*-----------------	Daten ----------------------------------*/
HAAS	haas =
{
	"SCHIFF.AAS",
	1,
	{
		"LINIENSCHIFF",
		32,32,
		{
			{0,0},
			{32,0},
			{64,0},
			{96,0},
			{128,0},
			{160,0},
			{192,0},
			{224,0},
			{256,0},
			{288,0},
			{320,0},
			{352,0},
			{384,0},
			{416,0},
			{448,0},
			{480,0}
		}
	}
};


