/*
	(c) 1993/1994 by TMMW Morus Walter
*/
#include "xchs.h"
#include "..\chs_ultd.gem\xchaos.h"

#define NUM_ROUT	5

XCHAOS *xchs[NUM_ROUT];

CHAOS_1	*xchs_1[NUM_ROUT];
CHAOS_2 *xchs_2[NUM_ROUT];
X__CHAOS xhu={X__CHAOS_ID,
		CHS_VERSION,
		NUM_ROUT,	/* zwei routinen */
		xchs_1,xchs_2
};

COMMON	*xcommon;			/* zeiger fr die routinen von chaos */
int errno;					/* damit der linker nicht motzt;
								sonst in pc_start deklariert */

/*------------------------------------------------------------------------------
		initialisierungsroutine,
			mu nach linken am anfang des text-segmentes stehen,
			d.h. im quelltext ganz vorne
------------------------------------------------------------------------------*/
X_CHAOS *ret_chaos(COMMON *com)
{
int i;
extern XCHAOS *barnsl,*lrnz,*diff,*popc,*kr;
void xinit_xchaos(void);

	xchs[0]=barnsl;
	xchs[1]=lrnz;
	xchs[2]=diff;
	xchs[3]=popc;
	xchs[4]=kr;

	xinit_xchaos();	/* chaos_1 & chaos_2 vollstndig ausfllen */

	for ( i=0; i<NUM_ROUT; i++ ) {
		xchs_1[i]=&xchs[i]->chaos_1;
		xchs_2[i]=&xchs[i]->chaos_2;
	}
	xcommon=com;					/* merke com */
	return (X_CHAOS*)&xhu;		/* gib eigene routinen zurck */
}

