#include "xchs.h"

		/* deklaration der zeichenroutine */
int XXX_draw(CHS_OBJC *objc,int width,int height,int colors,BITMAP *bitmap,int *xheight);

		/* zeiger auf die COMMON-struktur */
extern COMMON *xcommon;

typedef struct {		/* parameter des bildtyps */
	double xmin;		/* koordinaten (oder auch nicht!) */
	double xmax;
	double ymin;
	double ymax;

						/* parameter */

						/* flags (char) */

	long time;
	long iter;
	/* long pkte;		ntig, falls bild nicht zeilenweise berechnet wird */
} XXX;

typedef struct {		/* einstellungen fr den bildtyp */
	XXX start;
	XXX ende;
	char change[?];		/* nach zahl der koord+parameter dimensionieren */
} XXX_SET;

static RSIB0DATA[] =	/* das icon */
{ 0x0000, 0x0000, 0x0000, 0x0000, 
  0x0003, 0x9B54, 0x0000, 0x003E, 
  0x32D4, 0x0000, 0x07F8, 0xEDAA, 
  0x0000, 0x7007, 0x9B54, 0x0003, 
  0x0FFC, 0x64AA, 0x0004, 0x7007, 
  0x9B54, 0x0019, 0x87F8, 0xEDAA, 
  0x0036, 0x3E3E, 0x32D4, 0x002C, 
  0xF003, 0x9B54, 0x0009, 0xC1C1, 
  0xCD2A, 0x0059, 0x87F8, 0xEDAA, 
  0x005B, 0x8FF8, 0x64AA, 0x0093, 
  0x0FFC, 0x64AA, 0x00DB, 0x8FF8, 
  0x64AA, 0x00D9, 0x87F8, 0xEDAA, 
  0x0149, 0xC1C1, 0xCD2A, 0x016C, 
  0xF003, 0x9B54, 0x00B6, 0x3E3E, 
  0x32D4, 0x00D9, 0x87F8, 0xEDAA, 
  0x0124, 0x7007, 0x9B54, 0x0093, 
  0x0FFC, 0x64AA, 0x0124, 0x7007, 
  0x9B54, 0x0000, 0x0000, 0x0000
};

static ICONBLK rs_iconblk =	/* iconblock, die Maske (erster Eintrag) wird
								von xchaos.c eingetragen, falls wie hier 0l */
{ 0l, RSIB0DATA, "XXXXXXXX", 0x1000|'\0',
    1,   1,   0,   0,  48,  24,   0,  23,  48,   8,
};

static K_SET k_set=			/* voreinstellungen */
{
	{},		/* start */
	{},		/* ende */
	{}		/* change (flags fr interpolation) */
};

							/* voreinstellungen fr die allg.parameter */
static ALLG_PAR	k_apar={1,"XXX",640,400,1,0,2};

XCHAOS kreis={				/* XCHAOS: definition der parameter usw. */
	/* def */
{	1,	/* koords */				/* koordinaten ntig */
		/* typ      bezeichnug */
	{	{P_EMPTY,	""},			/* parameter */
		{P_EMPTY,	""},			/* P_INTEGER, P_LONG, P_DOUBLE */
		{P_EMPTY,	""},
		{P_EMPTY,	""},
		{P_EMPTY,	""},
		{P_EMPTY,	""}		},
		/* typ      bezeichnung zahl button-texte */
	{	{F_EMPTY,	0l,			0,	0l,0l,0l,0l,0l},	/* leer */
		{F_EMPTY,	0l,			0,	0l,0l,0l,0l,0l},	/* F_BUTTON, F_RBUTTON */
		{F_EMPTY,	0l,			0,	0l,0l,0l,0l,0l},
		{F_EMPTY,	0l,			0,	0l,0l,0l,0l,0l}		},

	0,	0l,	/* keine voreinst. */
	"xX_param",	"xX_neu",	"xX_spar",		/* hilfsdateien */
},
	/* chaos_1 (unvollstndig) */
{
	"XXX",					/* id */
	"XXX",					/* menue */
	"","",					/* autor, version & datum */
	"",						/* text	*/

	(uint)sizeof(XXX_SET),&XXX_set,	/* set_len/set */
	&XXX_apar,					/* allg. parameter */
	0,0,0,0l,0,					/* par_len, make_len, neu_len, trgt X_CHAOS ein */
	0,							/* xor_lines */
	0,							/* trgt X_CHAOS ein */
	{64,32000,40,32000,			/* min/max width/height */
	2,256,1},					/* min/max col, raster */
	0l,							/* x_mem, unused */

	0l,0l,0l,0l,0l,				/* trgt X_CHAOS ein */
	XXX_draw					/* zeichenroutine */ 
	/* ... -> 0l */				/* trgt X_CHAOS ein */
},
	/* chaos_2 (unvollstndig) */
{
	&rs_iconblk,				/* icon */
	"XXX",						/* name */
	1,							/* last-flag (1 -> bild zeilenweise, 0 -> immer ganzes bild speichern) */
	/* ... */					/* trgt X_CHAOS ein */
},
};

XCHAOS *_XXX=&XXX;

/*
	die berechnungsroutine
*/

int draw_kreis(CHS_OBJC *objc,int width,int height,int colors,BITMAP *bitmap,int *xheight)
{
XXX *param=(KREIS*)objc->param->data;
_xdraw_pkt draw;
MAKE_INFO mi;

		/* nicht ungecheckt bernehmen!!! */
	mi.width=width;
	mi.height=height;
	mi.pkte=-1;
	mi.iter=param->iter;
	mi.iter_ges=(long)width*(long)height;
	mi.time_iter=-1;
	mi.pkte_ges=-1;
	mi.time=param->time-xcommon->gettime();

	draw=xcommon->init_xdraw(bitmap,0,*xheight,DRAWMODE_SET,DRAW_MAXPUFFER);

/*
	eigentliche berechnung
	if ( xcommon->check_key(&mi) ) als abbruch-bedinung!!
*/

	param->time=mi.time+xcommon->gettime();
	param->iter=mi.iter;

	if ( mi.xheight<height )
		*xheight=mi.xheight;
	else
	*xheight=-1;
	return mi.state;
}

